#ifndef EARLIEST_EXECUTION_TABLE_H_INCLUDED_
#define EARLIEST_EXECUTION_TABLE_H_INCLUDED_

#include<vector>
#include "risc.h"

class EarlistExecutionTable {

public:

  EarlistExecutionTable(
      risc::sg::SegmentGraph &segment_graph,
      risc::sg::EventConflictTable &event_conflict_table);

  ~EarlistExecutionTable();

  void determine_table();

  void optimize_table();

  void print_table();

  risc::sg::Time& get_min_time(risc::sg::VertexIterator vertex_iter);

  /**
   * \brief    This vector is a lookup between the conflict table index and the
   *           associated segment index
   */
  std::vector<risc::sg::VertexIterator> table_index_segment_lookup_;

  //void optimize

  int size_;
  risc::sg::Time *table_;
  risc::sg::SegmentGraph &segment_graph_;
  risc::sg::EventConflictTable &event_conflict_table_;

  risc::sg::TimeAdvanceTable time_advance_table;
};

#endif /* EARLIEST_EXECUTION_TABLE_H_INCLUDED_ */
