#ifndef EXPRESSION_ANALYSIS_H_INCLUDED_
#define EXPRESSION_ANALYSIS_H_INCLUDED_

#include "rose.h"

extern std::set<SgFunctionDefinition*> future_functions;

void analyze_statement(SgStatement *stmt, std::set<SgVariableSymbol*> &read_variables, std::set<SgVariableSymbol*> &write_variables);

void analyze_expression(SgNode *expression,
    bool left_of_assignment, bool read_write, bool member_access,
    bool function_parameter, bool is_precached_function,
    SgVariableSymbol *outer_variable,
    std::set<SgVariableSymbol*> &read_variables,
    std::set<SgVariableSymbol*> &write_variables);

#endif /* EXPRESSION_ANALYSIS_H_INCLUDED_ */
