#ifndef REFERENCE_ATTRIBUTES_H_INCLUDED_
#define REFERENCE_ATTRIBUTES_H_INCLUDED_

#include "rose.h"

#include<set>

namespace risc {

namespace sg {

class FunctionParameterReferenceAttribute: public AstAttribute {

public:

  // for the new rose release
  virtual AstAttribute::OwnershipPolicy getOwnershipPolicy() const ROSE_OVERRIDE
  {
    return CONTAINER_OWNERSHIP;
  }

  std::set<SgVariableSymbol*> mapped_variables_;
};

class LocalReferenceAttribute: public AstAttribute {
public:

  // for the new rose release
  virtual AstAttribute::OwnershipPolicy getOwnershipPolicy() const ROSE_OVERRIDE
  {
    return CONTAINER_OWNERSHIP;
  }

  SgVariableSymbol *mapped_variable_;
};

} // end of namespace sg

} // end of namespace risc

#endif /* REFERENCE_ATTRIBUTES_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
