#include "systemc.h"

class ChannelInterface: virtual public sc_interface
{
public:
  virtual void func() = 0;
};

class Channel:
  public sc_channel,
  public ChannelInterface {

public:
  Channel(sc_module_name name):
    sc_channel(name)
  { }

  sc_event event;

  void func()
  {
    int before;
    wait(SC_ZERO_TIME);
    int middle;
    wait(SC_ZERO_TIME);
    int after;
  }

};

class Module: public sc_module {
public:

  SC_HAS_PROCESS(Module);
  sc_port<ChannelInterface> port_i;

  Module(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
  }

  void thread1()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          port_i->func();
          break;
        }
        case 2:
        {
          port_i->func();
          break;
        }
      }
    }
    int final_stmt;
  }

  void thread2()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          int FUNCTION_CALLA;
          int Abefore;
          wait(SC_ZERO_TIME);
          int Amiddle;
          wait(SC_ZERO_TIME);
          int Aafter;
          break;
        }
        case 2:
        {
          int FUNCTION_CALLB;
          int Bbefore;
          wait(SC_ZERO_TIME);
          int Bmiddle;
          wait(SC_ZERO_TIME);
          int Bafter;
          break;
        }
      }
    }
    int final_stmt;
  }

  void thread3()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          port_i->func();
        }
        case 2:
        {
          port_i->func();
        }
      }
    }
    int final_stmt;
  }

  void thread4()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {

          int FUNCTION_CALLA;
          int Abefore;
          wait(SC_ZERO_TIME);
          int Amiddle;
          wait(SC_ZERO_TIME);
          int Aafter;
        }
        case 2:
        {
          int FUNCTION_CALLB;
          int Bbefore;
          wait(SC_ZERO_TIME);
          int Bmiddle;
          wait(SC_ZERO_TIME);
          int Bafter;
        }
      }
    }
    int final_stmt;
  }
};

class Top: public sc_module {
public:

  Top(sc_module_name mn):
    sc_module(mn),
    m("m"),
    c("c")
  { }

  Channel c;
  Module m;

  void before_end_of_elaboration()
  {
    m.port_i.bind(c);
  }
};

class ChannelInterface2: virtual public sc_interface
{
public:
  virtual void func2() = 0;
};

class Channel2:
  public sc_channel,
  public ChannelInterface2 {

public:
  Channel2(sc_module_name name):
    sc_channel(name),
    x(4)
  { }

  sc_event event;

  void func2()
  {
    int before;
    if(x) {
      wait(SC_ZERO_TIME);
    }

    int middle;
    if(x) {
      wait(SC_ZERO_TIME);
    }

    int after;
  }
  int x;
};

class Module2: public sc_module {
public:

  SC_HAS_PROCESS(Module2);
  sc_port<ChannelInterface2> port_i;

  Module2(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    int a;
    wait(SC_ZERO_TIME);
    int b;
    port_i->func2();
    int c;
    wait(SC_ZERO_TIME);
    int d;
  }
};

class Top2: public sc_module {
public:

  Top2(sc_module_name mn):
    sc_module(mn),
    m2("m2"),
    c2("c2")
  { }

  Channel2 c2;
  Module2 m2;

  void before_end_of_elaboration()
  {
    m2.port_i.bind(c2);
  }
};


class TopTop: public sc_module {
public:

  Top t;
  Top2 t2;

  TopTop(sc_module_name mn):
    sc_module(mn),
    t("t"),
    t2("t2")
  { }
};

int sc_main(int argc, char **argv)
{
  TopTop t("tt");
  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
