#include "systemc.h"

volatile int m,n,o,p,q,r,s,t,u;

namespace test{
  volatile int a, b;
  void read_a()
  {
    a;
  }

  void write_a()
  {
    a++;
  }

  void read_b()
  {
    b;
  }

  void write_b()
  {
    b++;
  }

  void local_read_a()
  {
    volatile int a;
    a;
  }

  void local_write_a()
  {
    volatile int a;
    a++;
  }

  void local_read_b()
  {
    volatile int b;
    b;
  }

  void local_write_b()
  {
    volatile int b;
    b++;
  }

  void funct_var_reada(volatile int a)
  {
    a;
  }

  void funct_var_readb(volatile int b)
  {
    b;
  }

  void funct_var_writea(volatile int a)
  {
    a++;
  }

  void funct_var_writeb(volatile int b)
  {
    b++;
  }

  struct member{
    volatile int a;
    volatile int b;
  };

  member m;
  void member_reada()
  {
    m.a;
  }

  void member_readb()
  {
    m.b;
  }

  void member_writea()
  {
    m.a++;
  }

  void member_writeb()
  {
    m.b++;
  }


  struct sta_member{
    volatile static int a;
    volatile static int b;
  }; volatile int sta_member::a; volatile int sta_member::b;

  sta_member stam;
  void sta_member_reada()
  {
    stam.a;
  }

  void sta_member_readb()
  {
    stam.b;
  }

  void sta_member_writea()
  {
    stam.a++;
  }

  void sta_member_writeb()
  {
    stam.b++;
  }
}

class DataConflictTable: public sc_module {
public:
  // begin space for variables
  volatile int x, y, z;
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  // end space for variables

  SC_HAS_PROCESS(DataConflictTable);

  void data_conflict_table_1()
  {
    volatile int a;  // 0
    a = 2;
    wait(); // 1
    x;
    y;
    wait(); // 2
    z++;
  }

  void data_conflict_table_2()
  {
    volatile int b = 2; // 3
    x;
    y;
    wait(); // 4
    x;
    y;
    z;
    wait(); // 5
    z++;
    wait(); // 6
    x++;
  }

  void data_conflict_table_3()
  {
    volatile int a;
    wait();
    local_variable();
    wait();
    volatile int b;
  }

  void data_conflict_table_4()
  {
    volatile int a;
    wait();
    local_variable();
    wait();
    volatile int b;
  }

  void local_variable()
  {
    volatile int a, b, c;
    wait();
    c = a + b;
    wait();
    volatile int d;
  }

  void data_conflict_table_5()
  {
    volatile int a;
    wait();
    volatile int *i = &a;
    wait();
    volatile int b;
  }

  void data_conflict_table_6()
  {
    volatile int a;
    wait();
    volatile int *i = NULL;
    *i;
    wait();
    volatile int b;
  }

  void data_conflict_table_7()
  {
    volatile int a;
    wait();
    local_variable();
    wait();
    volatile int b;
  }

  struct MyStruct {
    volatile int x;
    volatile int y;
    volatile int z;
  };

  struct StaStruct{
    volatile static int x;
    volatile static int y;
  };

  MyStruct ms;
  MyStruct ms1;
  MyStruct ms2;
  MyStruct ms3;
  MyStruct ms4;

  void data_conflict_table_8()
  {
    ms.x = 10;
  }

  void data_conflict_table_9()
  {
    ms.x = 11;
  }

  void data_conflict_table_10()
  {
    ms1.x = 12;
  }

  void data_conflict_table_11()
  {
    MyStruct new_ms;
    ms1 = new_ms;
  }

  void data_conflict_table_12()
  {
    ms2.x = 13;
  }

  void data_conflict_table_13()
  {
    ms2.y = 14;
  }


  volatile int for_test_case_14;

  void for_test_case_14_only(int &ref)
  { }

  void data_conflict_table_14()
  {
    int ref;
    for_test_case_14_only(ref);
  }

  void for_test_case_15_only(volatile int *ptr)
  { }

  void data_conflict_table_15()
  {
    volatile int ptr;
    for_test_case_15_only(&ptr);
  }

  void data_conflict_table_16()
  {
    ms3.x;
    ms3.y;
    ms3.z;
  }

  void data_conflict_table_17()
  {
    ms3.x;
    ms3.y;
    ms3.z;
  }

  void data_conflict_table_18()
  {
    m;
  }

  void data_conflict_table_19()
  {
    m;
  }

  void data_conflict_table_20()
  {
    n++;
  }

  void data_conflict_table_21()
  {
    n++;
  }

  void data_conflict_table_22()
  {
    o;
  }

  void data_conflict_table_23()
  {
    o++;
  }

  void data_conflict_table_24()
  {
    p;
  }

  void data_conflict_table_25()
  {
    q;
  }

  void data_conflict_table_26()
  {
    r++;
  }

  void data_conflict_table_27()
  {
    s++;
  }

  void data_conflict_table_28()
  {
    t;
  }

  void data_conflict_table_29()
  {
    u++;
  }

  void data_conflict_table_30()
  {
    volatile static int aa;
    aa;
    wait();
    aa;
  }

  void data_conflict_table_31()
  {
    volatile static int aa;
    aa = 3;
    wait();
    aa = 4;
  }

  void data_conflict_table_32()
  {
    volatile static int aa;
    aa;
    wait();
    aa = 4;
  }

  void data_conflict_table_33()
  {
    volatile static int aa;
    volatile static int bb;
    aa;
    wait();
    bb;
  }

  void data_conflict_table_34()
  {
    volatile static int aa;
    volatile static int bb;
    aa++;
    wait();
    bb++;
  }

  void data_conflict_table_35()
  {
    volatile static int aa;
    volatile static int bb;
    aa;
    wait();
    bb++;
  }

  void data_conflict_table_36()
  {
    ms4.x = 3;

    wait();
    local_variable1();
    wait();
    ms4.x;
  }

  void data_conflict_table_37()
  {
    ms4.x;
    wait();
    local_variable1();

    wait();
    ms4.x++;
  }

  void local_variable1()
  {
    volatile int x;
    x++;
  }

  StaStruct ss;
  StaStruct ss1;
  StaStruct ss2;
  StaStruct ss3;
  StaStruct ss4;
  StaStruct ss5;
  void data_conflict_table_38()
  {
    ss.x;
    wait();
    ss.x;
  }

  void data_conflict_table_39()
  {
    ss1.x++;
    wait();
    ss1.x++;
  }

  void data_conflict_table_40(){
    ss2.x++;
    wait();
    ss2.x;
  }

  void data_conflict_table_41()
  {
    ss3.x;
    wait();
    ss3.y;
  }

  void data_conflict_table_42()
  {
    ss4.x++;
    wait();
    ss4.y++;
  }

  void data_conflict_table_43()
  {
    ss5.x;
    wait();
    ss5.y++;
  }

  void data_conflict_table_44()
  {
    volatile int x;
    for_test_case_44_only(x);
  }

  void for_test_case_44_only(volatile int x)
  {
    x;
    wait();
    x;
  }

  void data_conflict_table_45()
  {
    volatile int x;
    for_test_case_45_only(x);
  }

  void for_test_case_45_only(volatile int x)
  {
    x++;
    wait();
    x++;
  }

  void data_conflict_table_46()
  {
    volatile int x;
    for_test_case_46_only(x);
  }

  void for_test_case_46_only(volatile int x)
  {
    x;
    wait();
    x++;
  }

  void data_conflict_table_47()
  {
    volatile int x,y;
    for_test_case_47_only(x,y);
  }

  void for_test_case_47_only(volatile int x,volatile int y)
  {
    x;
    wait();
    y;
  }

  void data_conflict_table_48()
  {
    volatile int x,y;
    for_test_case_48_only(x,y);
  }

  void for_test_case_48_only(volatile int x,volatile int y)
  {
    x++;
    wait();
    y++;
  }

  void data_conflict_table_49()
  {
    volatile int x,y;
    for_test_case_49_only(x,y);
  }

  void for_test_case_49_only(volatile int x,volatile int y)
  {
    x;
    wait();
    y++;
  }

  void data_conflict_table_50()
  {
    test::read_a();
    wait();
    test::read_a();
  }

  void data_conflict_table_51()
  {
    test::write_a();
    wait();
    test::write_a();
  }

  void data_conflict_table_52()
  {
    test::read_a();
    wait();
    test::write_a();
  }

  void data_conflict_table_53()
  {
    test::read_a();
    wait();
    test::read_b();
  }

  void data_conflict_table_54()
  {
    test::write_a();
    wait();
    test::write_b();
  }

  void data_conflict_table_55()
  {
    test::read_a();
    wait();
    test::write_b();
  }

  void data_conflict_table_56()
  {
    test::local_read_a();
    wait();
    test::local_read_a();
  }

  void data_conflict_table_57()
  {
    test::local_write_a();
    wait();
    test::local_write_a();
  }

  void data_conflict_table_58()
  {
    test::local_write_a();
    wait();
    test::local_read_a();
  }

  void data_conflict_table_59()
  {
    test::local_read_a();
    wait();
    test::local_read_b();
  }

  void data_conflict_table_60()
  {
    test::local_write_a();
    wait();
    test::local_write_b();
  }

  void data_conflict_table_61()
  {
    test::local_write_a();
    wait();
    test::local_read_b();
  }

  struct SomeStruct {

    volatile int x;
    volatile int y;
  };

  SomeStruct some_struct_1;
  SomeStruct some_struct_2;

  void data_conflict_table_62()
  {
    some_struct_1.x = 2;
    wait();
    some_struct_2.x = 2;
  }

  struct SomeStruct1 {

    volatile static int x;
    volatile static int y;
  };

  SomeStruct1 some_struct_1_1;
  SomeStruct1 some_struct_1_2;

  void data_conflict_table_63()
  {
    some_struct_1_1.x = 2;
    wait();
    some_struct_1_2.x = 2;
  }

  void data_conflict_table_64()
  {
    SomeStruct1::y = 2;
    wait();
    SomeStruct1::y = 2;
  }

/*
 void funct_var_reada(int a)

  void funct_var_readb(int b)

  void funct_var_writea(int a)

  void funct_var_writeb(int b)
*/

  void data_conflict_table_65()
  {
    volatile int a;
    test::funct_var_reada(a);
    wait();
    test::funct_var_reada(a);
  }

  void data_conflict_table_66()
  {
    volatile int a;
    test::funct_var_writea(a);
    wait();
    test::funct_var_writea(a);
  }

  void data_conflict_table_67()
  {
    volatile int a;
    test::funct_var_reada(a);
    wait();
    test::funct_var_writea(a);
  }

  void data_conflict_table_68()
  {
    volatile int a;
    volatile int b;
    test::funct_var_reada(a);
    wait();
    test::funct_var_readb(b);
  }

  void data_conflict_table_69()
  {
    volatile int a;
    volatile int b;
    test::funct_var_writea(a);
    wait();
    test::funct_var_writeb(b);
  }

  void data_conflict_table_70()
  {
    volatile int a;
    volatile int b;
    test::funct_var_reada(a);
    wait();
    test::funct_var_writeb(b);
  }

  void data_conflict_table_71()
  {
    test::member_reada();
    wait();
    test::member_reada();
  }

  void data_conflict_table_72()
  {
    test::member_writea();
    wait();
    test::member_writea();
  }

  void data_conflict_table_73()
  {
    test::member_reada();
    wait();
    test::member_writea();
  }

  void data_conflict_table_74()
  {
    test::member_reada();
    wait();
    test::member_readb();
  }

  void data_conflict_table_75()
  {
    test::member_writea();
    wait();
    test::member_writeb();
  }

  void data_conflict_table_76()
  {
    test::member_reada();
    wait();
    test::member_writeb();
  }

  void data_conflict_table_77()
  {
    test::sta_member_reada(); // 0
    wait();
    test::sta_member_reada(); // 2
  }

  void data_conflict_table_78()
  {
    test::sta_member_writea(); // 3
    wait();
    test::sta_member_writea(); // 5
  }

  void data_conflict_table_79()
  {
    test::sta_member_reada(); // 6
    wait();
    test::sta_member_writea(); // 7
  }

  void data_conflict_table_80()
  {
    test::sta_member_reada(); // 9
    wait();
    test::sta_member_readb(); // 10
  }

  void data_conflict_table_81()
  {
    test::sta_member_writea(); // 11
    wait();
    test::sta_member_writeb(); // 12
  }

  void data_conflict_table_82()
  {
    test::sta_member_reada(); // 14
    wait();
    test::sta_member_writeb(); // 15
  }

  void data_conflict_table_83()
  {
    volatile static int i;
    i++;
    wait();
    i++;
  }

  struct SomeOtherStruct {
    volatile static int x;
  };

  void data_conflict_table_84()
  {
    SomeOtherStruct sos;
    sos.x++;
    wait();
    sos.x++;
  }


  void data_conflict_table_85()
  {
    printf("Hello World!");
    wait(SC_ZERO_TIME);
  }

  #pragma RISC  pragma_var   conflict-free
  int not_this_one, pragma_var, not_that_one;

  void data_conflict_table_86()
  {
    pragma_var++;
  }

  void data_conflict_table_87()
  {
    pragma_var++;
  }

  DataConflictTable(sc_module_name mn): sc_module(mn)
  {
    #if 1
    SC_THREAD(data_conflict_table_1);
    SC_THREAD(data_conflict_table_2);

    // Test case for local variables.
    // Both threads should have no conflicts.
    SC_THREAD(data_conflict_table_3);
    SC_THREAD(data_conflict_table_4);
    SC_THREAD(data_conflict_table_7);

    // Test case for address of operator
    // Both test cases should have one blocked row/column
    SC_THREAD(data_conflict_table_5);
    SC_THREAD(data_conflict_table_6);

    // Member analysis
    // conflict
    SC_THREAD(data_conflict_table_8);
    SC_THREAD(data_conflict_table_9);

    //conflict
    SC_THREAD(data_conflict_table_10);
    SC_THREAD(data_conflict_table_11);

    // conflict free
    SC_THREAD(data_conflict_table_12);
    SC_THREAD(data_conflict_table_13);

    // conflicht with all because of reference
    SC_THREAD(data_conflict_table_14);

    // conflicht with all because of pointer
    SC_THREAD(data_conflict_table_15);

    // read members in parallel
    SC_THREAD(data_conflict_table_16);
    SC_THREAD(data_conflict_table_17);

    // globle variable: read the same variable
    SC_THREAD(data_conflict_table_18);
    SC_THREAD(data_conflict_table_19);

    SC_THREAD(data_conflict_table_20);
    SC_THREAD(data_conflict_table_21);

    // globle variable: read and write the same variable
    SC_THREAD(data_conflict_table_22);
    SC_THREAD(data_conflict_table_23);

    // globle variable: read different variables
    SC_THREAD(data_conflict_table_24);
    SC_THREAD(data_conflict_table_25);

    // globle variable: write different variables
    SC_THREAD(data_conflict_table_26);
    SC_THREAD(data_conflict_table_27);

    // globle variable: read and write different variables
    SC_THREAD(data_conflict_table_28);
    SC_THREAD(data_conflict_table_29);

    // static variable: read the same variable
    SC_THREAD(data_conflict_table_30);

    // static variable: write the same variable
    SC_THREAD(data_conflict_table_31);

    // static variable: read and write the same variable
    SC_THREAD(data_conflict_table_32);

    // static variable: read two different variables;
    SC_THREAD(data_conflict_table_33);

    // static variable: write two different variables;
    SC_THREAD(data_conflict_table_34);

    // static variable: read and write two different variables;
    SC_THREAD(data_conflict_table_35);

    // parallel test with a mix of reading and writing with class and local
    // variables
    SC_THREAD(data_conflict_table_36);
    SC_THREAD(data_conflict_table_37);

    // static member variable read (single variable)
    SC_THREAD(data_conflict_table_38);

    // static member variable read (multiple variables)
    SC_THREAD(data_conflict_table_41);

    // function parameter read (single variable)
    SC_THREAD(data_conflict_table_44);

    // function parameter read (multiple variables)
    SC_THREAD(data_conflict_table_47);

    // namespace globle var read (single variable)
    SC_THREAD(data_conflict_table_50);

    // namespace globle var write (single variable)
    SC_THREAD(data_conflict_table_51);

    // namespace globle var read and write (single variable)
    SC_THREAD(data_conflict_table_52);

    // namespace globle var read (multiple variables)
    SC_THREAD(data_conflict_table_53);

    // namespace globle var write (multiple variables)
    SC_THREAD(data_conflict_table_54);

    // namespace globle var read and write (multiple variables)
    SC_THREAD(data_conflict_table_55);

    // namespace local var read (single variable)
    SC_THREAD(data_conflict_table_56);

    // namespace local var write (single variable)
    SC_THREAD(data_conflict_table_57);

    // namespace local var read and write (single variable)
    SC_THREAD(data_conflict_table_58);

    // namespace local var read (multiple variables)
    SC_THREAD(data_conflict_table_59);

    // namespace local var write (multiple variables)
    SC_THREAD(data_conflict_table_60);

    // namespace local var read and write (multiple variables)
    SC_THREAD(data_conflict_table_61);

    // static member variable write (single variable)
    SC_THREAD(data_conflict_table_39);

    // static member variable read and write (single variable)
    SC_THREAD(data_conflict_table_40);

    // static member variable write (multiple variables)
    SC_THREAD(data_conflict_table_42);

    // static member variable read and write (multiple variables)
    SC_THREAD(data_conflict_table_43);

    // function parameter write (single variable)
    SC_THREAD(data_conflict_table_45);

    // function parameter read and write (single variable)
    SC_THREAD(data_conflict_table_46);

    // function parameter write (multiple variables)
    SC_THREAD(data_conflict_table_48);

    // function parameter read and write (multiple variables)
    SC_THREAD(data_conflict_table_49);

    // Writing a static member variable through two different objects
    // Access via dot operator
    SC_THREAD(data_conflict_table_63);

    // Writing a static member variable through two different objects
    // Access via :: operator
    SC_THREAD(data_conflict_table_64);


    // namespace func var read (single variable)
    SC_THREAD(data_conflict_table_65);
    // namespace func var write (single variable)
    SC_THREAD(data_conflict_table_66);
    // namespace func var read and write (single variable)
    SC_THREAD(data_conflict_table_67);
    // namespace func var read (multiple variables)
    SC_THREAD(data_conflict_table_68);
    // namespace func var write (multiple variables)
    SC_THREAD(data_conflict_table_69);
    // namespace func var read and write (multiple variables)
    SC_THREAD(data_conflict_table_70);

    // namespace member var read (single variable)
    SC_THREAD(data_conflict_table_71);
    // namespace member var write (single variable)
    SC_THREAD(data_conflict_table_72);
    // namespace member var read and write (single variable)
    SC_THREAD(data_conflict_table_73);
    // namespace member var read (multiple variables)
    SC_THREAD(data_conflict_table_74);
    // namespace member var write (multiple variables)
    SC_THREAD(data_conflict_table_75);
    // namespace member var read and write (multiple variables)
    SC_THREAD(data_conflict_table_76);

    // namespace static member var read (single variable)
    SC_THREAD(data_conflict_table_77);
    // namespace static member var write (single variable)
    SC_THREAD(data_conflict_table_78);
    // namespace static member var read (multiple variables)
    SC_THREAD(data_conflict_table_80);
    // namespace static member var read and write (single variable)
    SC_THREAD(data_conflict_table_79);
    // namespace static member var write (multiple variables)
    SC_THREAD(data_conflict_table_81);
    // namespace static member var read and write (multiple variables)
    SC_THREAD(data_conflict_table_82);

    // test for static variables in functions
    SC_THREAD(data_conflict_table_83);
    // test for static variables in functions
    SC_THREAD(data_conflict_table_84);

    // test of function calls which take only literals: printf("hello world")
    SC_THREAD(data_conflict_table_85);

    // writing two some member variable of two different struct instances.
    // This should be not a conflict
    // This test case doesn't work
    //SC_THREAD(data_conflict_table_62);

    SC_THREAD(data_conflict_table_86);
    SC_THREAD(data_conflict_table_87);
    #endif

  }
}; volatile int DataConflictTable::StaStruct::x; volatile int DataConflictTable::StaStruct::y; volatile int DataConflictTable::SomeStruct1::x; volatile int DataConflictTable::SomeStruct1::y; volatile int DataConflictTable::SomeOtherStruct::x;


SC_MODULE(ParA)
{
  int var_;
  int &ref_;

  SC_HAS_PROCESS(ParA);

  ParA(sc_module_name mn, int &ref):
    sc_module(mn),
    ref_(ref)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  void thread1()
  {
    var_ = 5;
  }

  void thread2()
  {
    ref_ = 8;
  }
};

SC_MODULE(ParB)
{
  ParA a1;
  ParA a2;

  int conflict_ref;

  SC_CTOR(ParB):
    a1("a1", conflict_ref),
    a2("a2", conflict_ref)
  {
  }
};

class ParC: public sc_module {

public:
  SC_HAS_PROCESS(ParC);

  ParC(sc_module_name mn, int &ref_1, int &ref_2):
    sc_module(mn),
    ref_c_1(ref_1),
    ref_c_2(ref_2)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  int &ref_c_1;
  int &ref_c_2;

  void thread1()
  {
    ref_c_1 = 3;
  }

  void thread2()
  {
    ref_c_2 = 3;
  }
};

class ParD: public sc_module {

public:
  SC_HAS_PROCESS(ParD);

  ParD(sc_module_name mn, int &ref_1, int &ref_2):
    sc_module(mn),
    ref_d_1(ref_1),
    ref_d_2(ref_2)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  int &ref_d_1;
  int &ref_d_2;

  void thread1()
  {
    ref_d_1 = 3;
  }

  void thread2()
  {
    ref_d_2 = 3;
  }
};

class ParE: public sc_module {

public:
  int var1, var2, var3;
  ParC parc;
  ParD pard;

  ParE(sc_module_name mn):
    sc_module(mn),
    parc("parc", var1, var2),
    pard("pard", var1, var3)
  {
  }
};

class A: public sc_module {
public:
  SC_HAS_PROCESS(A);

  int &refa_;

  A(sc_module_name mn, int &refa):
    sc_module(mn),
    refa_(refa)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    refa_ = 5;
  }
};

class B: public sc_module {
public:
  SC_HAS_PROCESS(B);

  int &refb_;

  B(sc_module_name mn, int &refb):
    sc_module(mn),
    refb_(refb)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    refb_ = 6;
  }
};

class HostAB: public sc_module {
public:

  SC_HAS_PROCESS(HostAB);

  HostAB(sc_module_name mn, int &ref_):
    sc_module(mn),
    a_("A", ref_),
    b_("B", ref_)
  { }

  A a_;
  B b_;
};

class Middle: public sc_module {

public:
  HostAB left_;
  HostAB right_;

  int left_ref, right_ref;

  Middle(sc_module_name mn):
    sc_module(mn),
    left_("left", left_ref),
    right_("right", right_ref)
  {
  }
};

int global;

class GlobalModule: public sc_module {

public:
  int &ref_global;

  SC_HAS_PROCESS(GlobalModule);


  GlobalModule(sc_module_name mn, int &ref):
    ref_global(ref)
  {
    SC_THREAD(thread);
  }

  void thread()
  {
    ref_global = 5;
  }
};


class TopMiddle: public sc_module {

public:
  Middle m1_;
  Middle m2_;

  GlobalModule global_module1_;
  GlobalModule global_module2_;

  TopMiddle(sc_module_name mn):
    sc_module(mn),
    m1_("m1"),
    m2_("m2"),
    global_module1_("g1", global),
    global_module2_("g2", global)
  {
  }
};

class Module: public sc_module {
public:

  static int static_var_module;

  SC_HAS_PROCESS(Module);

  Module(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    static_var_module++;
  }
};
int Module::static_var_module = 0;

class Module1: public sc_module {
public:

  static int static_var_module1;

  SC_HAS_PROCESS(Module1);

  Module1(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  void thread1()
  {
    static_var_module1++;
  }

  void thread2()
  {
    int i = static_var_module1;
  }
};
int Module1::static_var_module1 = 0;

class Top: public sc_module {
public:
  Module m1;
  Module m2;

  Module1 m11;
  Module1 m12;

  Top(sc_module_name mn):
    sc_module(mn),
    m1("m1"),
    m2("m2"),
    m11("m11"),
    m12("m12")
  { }
};


class DataConflictTableTop: public sc_module {
public:

  DataConflictTable dct;
  ParB parb;
  ParE pare;
  TopMiddle tm; // test of global variables
                // example with multiple instances (HostAB)
  Top t;

  DataConflictTableTop(sc_module_name mn):
    sc_module(mn),
    dct("dct"),
    parb("parb"),
    pare("pare"),
    tm("tm"),
    t("top")
  {
  }
};


#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  //DataConflictTable mm("mm");
  DataConflictTableTop mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
